/*
	Default immediate action keys.
	Other functions call this instead of calling Kget() directly.
	This allows functions such as "print screen" to be implemented
	everywhere.
*/
#include <keyboard.h>
#include <pscreen.h>

int getkey(void) {
  Ksync();
  for (;;) {
    fskey = Kget();
    switch (fskey) {
    case KEY_PRINT:
      {
	int euid = geteuid();
	int egid = getegid();
	setuid(getuid());
	setgid(getgid());
	PSprtscr("scrndump");
	setuid(euid);
	setgid(egid);
	continue;
      }
    case KEY_REFRESH:
      PSrefresh();
      PSsync();
      continue;
    }
    return fskey;
  }
}
