#pragma interface
#include "component.h"

class Choice: public Component {
  struct StrList;
  StrList &txt;
  int cursel,maxwidth;
  bool inPopup;
public:
  Choice();
  ~Choice();
  void remoteMethod(int cmd);
  void addItem(const String &,int);
  void remove(int);
  void select(int);
  int countItems() const;
  int getSelectedIndex() const;
  const char *operator[](int);
  const String &getItem(int) const;
  const String &getSelectedItem() const;
  void paint(DrawingContext *);
  void getfocus();
  void key(int k);
};

class ListComponent: public Component {
  class StringList &txt;
  class LongSet &selected;
  int topline, curline;
  bool multi;
public:
  ListComponent();
  ~ListComponent();
  void remoteMethod(int cmd);
  void addItem(const String &,int);
  void remove(int beg,int end);
  void select(int);
  void deselect(int);
  void removeAll();
  void setMultipleMode(bool b) { multi = b; }
  void makeVisible(int);
  void paint(DrawingContext *);
  void key(int);
  void getfocus();
};
