#ifndef __TextBrowse_h
#define __TextBrowse_h
#pragma interface
#include "browse.h"
#include "component.h"
#include "textselect.h"
#include <textlist.h>
class String;
struct TextBrowse: virtual BrowserBase, Component, TextSelection {
  TextBrowse(class TextArray &);
  CHTYPE operator()(int,int) const;
  int lines() { return txt.size(); }
  void move(int,int);
  void getyx(int &,int &) const;
  void paint(class DrawingContext *);
  void slide(const Rect &r,Dir d,int cnt);
  void select(long start,long end);
  void show(bool);
  Dimension size() const;
  void print();
  void selectionChanged(int,int,int,int);
  /* void search(const char *); */
  void getfocus();
  void setEchoChar(char c) { echoChar = c; }
  void setCursor(int x,int y);
  ~TextBrowse();
private:
  char echoChar;
  TextBrowse(const TextBrowse &);
  TextBrowse&operator=(const TextBrowse &);
};
#endif
