#ifndef __TOOLKIT_H
#define __TOOLKIT_H
#pragma interface
#include <Array.h>
#include <Select.h>
#include <Controller.h>

// a connection to a Java awt toolkit
class Component;
class Dialog;
class String;

class Toolkit: private SelectPoll, public Controller {
  int fd;
  struct FILE *f;
  Array<Component *> objs;
  Array<Dialog *> allFrames;
  class Background *backgrnd;
  char dumpargs;
  char argcnt;
  void logarg(int);
  void logarg(const char *);
  void handler();
public:
  bool trace;
  bool localtabs;
  int scalex, scaley;
  Toolkit(int f);
  void addComponent(Component *obj,int id);
  void addFrame(Dialog *w);	// add Dialog to task list
  int findFrame(Component *w);
  void removeFrame(Component *w);	// remove from task list
  Dialog *pickList();	// select 
  Component *componentAt(int i);
  void delComponent(int);
  Component *removeComponentAt(int i);
  void key(int k);
  void init(int sx,int sy);
  int run();
  void writeShort(int val);
  void writeUTF(const String &);
  void readFully(char *buf,int len);
  void callMethod(int id,int cmd,const char *buf,int len);
  void callMethod(int id,int cmd,const String &str);
  void callMethod(int id,int cmd,int x);
  void callMethod(int id,int cmd,int x,int y);
  void callMethod(int id,int cmd,int x,int y,int w,int h);
  void callMethod(int id,int cmd);
  bool avail();		// true if remote commands available
  int readShort();
  String readUTF();
  int runProg(String cmd);
  ~Toolkit();
};
#endif
